/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define INTERVAL   50    /* Υߥ */
#define ARC        40    /* ߤΥ */
#define LEFT        0    /* ɤ x ɸ */
#define RIGHT     400    /* ɤ x ɸ */
#define Y          80    /* ߤ y ɸ */
#define STEP        5    /* 1ޤǰưΥ */
#define LtoR        0    /* ߤΰư: 鱦 */
#define RtoL        1    /* ߤΰư: 麸 */

static GC gc;
static XtIntervalId timeout_id;
static int position = LEFT;  /* ߤαߤ x ɸ */
static int direction = LtoR;  /* LtoR: ˰ư, RtoL: ˰ư */
static Pixmap front, back;  /* ԥåޥåסХåե */
static Dimension width, height;

static void TimeoutCB(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget w = (Widget)client_data;
    Pixmap tmp;

    /* (3) Хåե򥯥ꥢ */
    XSetForeground(XtDisplay(w), gc, WhitePixelOfScreen(XtScreen(w)));
    XFillRectangle(XtDisplay(w), back, gc, 0, 0, width, height);

    /* αߤΰ֤ */
    if (direction == LtoR) {             /* ޤǺ鱦ưƤ */
        position += STEP;                /* ΰ֤˿ʤ */
        if (position > (RIGHT - ARC)) {  /* ɤäȿž */
            position = (RIGHT - ARC) - (position - (RIGHT - ARC));
            direction = RtoL;
        }
    }
    else { /* direction == RtoL */  /* ޤǱ麸ưƤ */
        position -= STEP;           /* ΰ֤˿ʤ */
        if (position < LEFT) {      /* ɤäȿž */
            position = LEFT - (position - LEFT);
            direction = LtoR;
        }
    }

    /* ߤοϹ */
    XSetForeground(XtDisplay(w), gc, BlackPixelOfScreen(XtScreen(w)));
    /* (4) ΰ֤˱ߤ */
    XFillArc(XtDisplay(w), back, gc, position, Y, ARC, ARC, 0*64, 360*64);

    /* ƤӥॢȡХåƤӽФ褦ˤ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(w),
                                 INTERVAL, TimeoutCB, w);

    /* (5) Хåեڤؤ */
    tmp = front;
    front = back;
    back = tmp;

    /* (6) ХåեƤɥꥢ˥ԡ */
    XCopyArea(XtDisplay(w), front, XtWindow(w), gc, 0, 0, width, height, 0, 0);
}

/* (7) ɥꥢϪФȡХåեƤ򥳥ԡ */
static void ExposeCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XCopyArea(XtDisplay(w), front, XtWindow(w), gc, 0, 0, width, height, 0, 0);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, canvas;
    Arg al[20];
    int ac;
    int depth;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Animation", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtAddCallback(canvas, XmNexposeCallback, ExposeCB, NULL);
    XtManageChild(canvas);

    XtRealizeWidget(toplevel);

    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);

    /* ɥꥢΥɥΥ depth Ĵ٤ */
    XtVaGetValues(canvas, XmNwidth, &width,
                          XmNheight, &height,
                          XmNdepth, &depth, NULL);

    /* (1) ɥꥢƱ depth ǥԥåޥåפ 2ĺ */
    front = XCreatePixmap(XtDisplay(canvas), XtWindow(canvas),
                          width, height, depth);
    back = XCreatePixmap(XtDisplay(canvas), XtWindow(canvas),
                         width, height, depth);

    /* (2) ԥåޥåפ򥯥ꥢƤ (ɤĤ֤) */
    XSetForeground(XtDisplay(canvas), gc, WhitePixelOfScreen(XtScreen(canvas)));
    XFillRectangle(XtDisplay(canvas), front, gc, 0, 0, width, height);
    XFillRectangle(XtDisplay(canvas), back, gc, 0, 0, width, height);

    /* ॢȡХåϿ */
    timeout_id = XtAppAddTimeOut(app_context, INTERVAL, TimeoutCB, canvas);

    XtAppMainLoop(app_context);
}
